﻿var slist = "";
for (i = 0; i < app.activeDocument.paragraphStyles.length; i++) {
	slist = slist + app.activeDocument.paragraphStyles[i].name + ",";
	}
for (i = 0; i < app.activeDocument.paragraphStyleGroups.length; i++) {
	tmpStr = app.activeDocument.paragraphStyleGroups[i].name;
	for (j = 0; j < app.activeDocument.paragraphStyleGroups[i].paragraphStyles.length; j++) {
		slist = slist + tmpStr + " ∽∽ " + app.activeDocument.paragraphStyleGroups[i].paragraphStyles[j].name + ",";
		}
	}
slist = slist.replace ("[段落スタイルなし],[基本段落],", "");
slist = slist.substring (0, slist.length-1);
slist = slist.split (",");

var preList = "";
for (i = 0; i < app.pdfExportPresets.length; i++) {
	preList = preList + app.pdfExportPresets[i].name + ",";
	}
preList = preList.substring (0, preList.length-1);
preList = preList.split (",");

dlg = app.dialogs.add({name:"画像配置スクリプト"});
dlc = dlg.dialogColumns.add();
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:"【段落スタイル】"});
	}
with(dlc.dialogRows.add()){ 
	myPStyle = dropdowns.add({stringList: slist, selectedIndex:0, minWidth:260});
	}
with(dlc.dialogRows.add()){ 
	staticTexts.add({staticLabel:"【PDFプリセット】"});
	}
with(dlc.dialogRows.add()){ 
	myPreset = dropdowns.add({stringList: preList, selectedIndex:0, minWidth:260});
	}
flag = dlg.show();

if (flag == true) {
	if (slist == "") {
		alert("段落スタイルが設定されていません。");
		exit();
		}
	app.findGrepPreferences = NothingEnum.nothing;
	var tmpPStyle = myPStyle.stringList[myPStyle.selectedIndex];
	if (tmpPStyle.match (" ∽∽ ")) {
		PStyle = tmpPStyle.split(" ∽∽ ");
		app.findGrepPreferences.appliedParagraphStyle = app.activeDocument.paragraphStyleGroups.itemByName(PStyle[0]).paragraphStyles.itemByName(PStyle[1]);
		} else {app.findGrepPreferences.appliedParagraphStyle = tmpPStyle;}
	var fnText = app.activeDocument.findGrep();
	main(fnText);
	}


function main(fnText) {
	var pdfPreset = myPreset.stringList[myPreset.selectedIndex];
	
	//PDFを保存するフォルダを選択
	var folderName = Folder.selectDialog("PDFを保存するフォルダを選択") ;

	//ページ変数初期化
	var myPage = [];
	var tmpNum = 0;

	if (fnText.length > 0) {
		for (var i = 0; i < fnText.length; i++) {
			var tmpConst = fnText[i];
			while(tmpConst.parent.constructor.name != "Spread") {
					switch(tmpConst.constructor.name) {
						case "Paragraph":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
						case "TextStyleRange":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
						case "Character":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
						case "Word":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
						case "InsertionPoint":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
						case "TextColumn":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
						case "Line":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
						case "Text":tmpSel = tmpConst = tmpConst.parentTextFrames[0]; break;
						default: tmpConst = tmpConst.parent;
					}
				}
			try {
				myPage[i] = tmpConst.parentPage.documentOffset;
				tmpNum++;
				} catch(e) {}
			}
		myPage.sort(function(a,b) {return a-b;});
		for (var i = 0; i < myPage.length; i++) {
			var startPage = myPage[i] + 1;
			var endPage = myPage[i+1];
			if (startPage-1 != endPage) {
				if (endPage == undefined) {endPage = app.activeDocument.pages.length};
				tmpSnum = app.activeDocument.pages[startPage-1].name;
				tmpEnum = app.activeDocument.pages[endPage-1].name;
				app.pdfExportPreferences.pageRange = "+" + startPage + "-" + "+" +endPage;
				var tmpName = app.activeDocument.name;
				var fileName = tmpName.replace(".indd", "");
				if (tmpSnum == tmpEnum) {
					fileName = folderName+"/"+fileName + "_" + tmpSnum +".pdf";
					} else {
						fileName = folderName+"/"+fileName + "_" + tmpSnum + "-" + tmpEnum +".pdf";
						}
				app.activeDocument.exportFile(ExportFormat.pdfType, File(fileName), false, pdfPreset);
				}
			}
		}
	}
